#! /usr/bin/perl
#------------------------------------------------------------------
# YOU ARE COMING TO THE DESTINATION ALMOST. PLEASE DO A LITTLE EFFORT.
#
# How to setup search form of htags
# =================================
#
# You should start HTTP server so that this script is executed as a CGI script.
# Setup procedure for it depends on the HTTP server which you are using.
# If you are using Apache, 'HTML/.htaccess' might be helpful for you.
#
#------------------------------------------------------------------
#
# Copyright (c) 1997, 2004, 2006, 2008, 2010 Tama Communications Corporation
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
sub header {
	"Content-type: text/html\n\n" .
	"@page_begin\n@body_begin\n";
}
sub tailer {
	"@body_end\n@page_end\n";
}
sub title {
	"@title_begin@" . $_[0] . "@title_end@\n";
}
sub error {
	"@error_begin@Error@error_end@\n";
}
sub message {
	"@message_begin@" . $_[0] . "@message_end@\n";
}
sub form {
   if ($ENV{'REQUEST_METHOD'} eq "POST") {
       read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   } else {
       $buffer = $ENV{'QUERY_STRING'};
   }
   @pairs = split(/&/,$buffer);
   # 各パラメータを配列に格納する
   foreach $pair (@pairs) {
       ($name, $value) = split(/=/, $pair);
       # フォーム名と値に分解
       $value =~ tr/+/ /;
       $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
       $form{$name} = $value;
#		print header();
#		print message($ENV{'REQUEST_METHOD'} . $buffer . "<a href='../../mains.html'> FORM(" . $name . ")=" . $form{$name} . "[return]</a>");
#		print tailer();
   }
}
sub error_and_exit {
	print header();
	print error();
	print message($_[0] . "<a href='$basedir/mains.html'>[return]</a>");
	print tailer();
	exit 0;
}
sub input {
	$line = (@line > 0) ? shift @line : <PIPE>;
	return $line;
}

### 性能測定のための処理雛形
#my($starttimes_user) = (times())[0];
# 実行時間を計測したい処理をここに記述
#@flline = <YTF>;
#my($endtimes_user) = (times())[0];
#my $exectimes_user=$endtimes_user-$starttimes_user;
#print message("[$exectimes_user]秒");




# 初期設定 cgi-bin がHTMLファイルのどの場所にあるか確認する
# mains.htmlやS（ソースファイルのhtml）が置かれているトップ場所を設定
$basedir = "../..";

# gtags コマンドの存在確認
if (! -x '/usr/bin/gtags') {
	error_and_exit("Server side command not found. <a href='$basedir/mains.html'>MAINS-list [return]</a>");
}

<<<<<<< HEAD
=======
# 初期設定 cgi-bin がHTMLファイルのどの場所にあるか確認する
# mains.htmlやS（ソースファイルのhtml）が置かれているトップ場所を設定
$basedir = "..";
>>>>>>> b8103acd68cc7b4d7f09ad17c7d01afef190b31b
# コメント更新のデータを取得
&form();

# ハッシュリストのkeyと値を取得。これは、htmlファイル名-6桁idと更新するコメントとなる
foreach $flnmid (keys(%form)) {
    ($flnm,$id) = split(/-/,$flnmid);
    if (defined($id)) {
<<<<<<< HEAD
        ##### htags/src2html.c で textarea を挿入する。そのフォーマットを必須参照
        $pointarea = "textarea name=\'" . $flnmid ."\' value=\'\'";
        # 編集対象及び rehash 用 URLファイルを格納する
        $urlflnm = $flnm;
        $jmpoint = $flnmid;
        # textarea に記述された内容を格納する
        $comupinfo = $form{$flnmid};
#		print header();
#		print message("SearchPattern(" . $pointarea . ") Filename(" . $flnm . ", id<" . $id . ">) Comment(" . $form{$flnmid} . ")<" . $urlflnm . "," . $jmpoint . ">\n");
#		print tailer();
=======
        $pointarea = "textarea rows=\'1\' name=\'" . $flnmid ."\' value=\'\'";
#		print header();
#		print message("SearchPattern(" . $pointarea . ") Filename(" . $flnm . ", id<" . $id . ">) Comment(" . $form{$flnmid} . ")\n");
#		print tailer();
        $comupinfo = $form{$flnmid};
        $Lflnmid=$flnmid;
>>>>>>> b8103acd68cc7b4d7f09ad17c7d01afef190b31b
	} else {
        next;
	}
}

$cnt=0;
<<<<<<< HEAD
# 更新対象ファイルを読み込む
open(YTF,"$basedir/S/$flnm")  or error_and_exit("Not Found $flnm");
while(<YTF>) {
    # コメント更新されたフィールドかどうか判断
=======
open(YTF,"$basedir/$flnm")  or error_and_exit("NOT Found $flnm");
while(<YTF>) {
    #my($starttimes_user) = (times())[0];
    # 実行時間を計測したい処理をここに記述
    #@flline = <YTF>;
    #my($endtimes_user) = (times())[0];
    #my $exectimes_user=$endtimes_user-$starttimes_user;
    #print message("[$exectimes_user]秒");

>>>>>>> b8103acd68cc7b4d7f09ad17c7d01afef190b31b
    if($_ =~ /$pointarea/) {
        $fieldcnt = split(/textarea/,$_);
        # 既に改行付きコメントが挿入されているか判断
        # fieldcnt が3以上の場合は改行なしコメントか初期状態であると判断
        if($fieldcnt >= 3){
            # 3以上あれば<textarea cols='1' name='xxx'>[yyy]</textarea><input ～>と想定して、
            # HTMLタグの間に既存コメントがあった場合は削除・無設定の場合、更新コメントを挿入
<<<<<<< HEAD
            # s///で置換する
            $_ =~ s/value=\'\'\>*\<\/textarea\>/value=\'\'\>$comupinfo\<\/textarea\>/;
            # 前回の更新と今の更新の比較を行う処理を追加するため追加。しばらく無処理。
            # 改行無しのコメントであるから以下の様に格納する
            $_ =~ m/value=''>(.*)<\/textarea>/;
            $precoment = $&;
            # 書き出し用配列に格納
            $oneline[$cnt++] = $_;
        }elsif($fieldcnt == 2){
            $_ =~ m/(value=''>)/;
            $precoment = $precoment . $';
            # 改行が含まれるため、それを削除
            #chomp($comupinfo);
            # HTML 要素と改行付きコメントがあると想定しての処理
            $_ =~ s/value=\'\'\>.*/value=\'\'\>$comupinfo/;
            # 書き出し用配列に格納
            # 改行が追加されないように繋げて格納するため$cntをインクリメントしない
            $oneline[$cnt++] = $_;
            while(<YTF>){
                if($_ =~ /\<\/textarea\>/){
                    $_ =~ m/.*(<\/textarea>)/;
                    $precoment = $precoment . $`;
                    $_ =~ s/.*\<\/textarea\>/\<\/textarea\>/;
                    # 改行が追加されないように繋げて格納する
                    $oneline[$cnt++] .= $_;
=======
            $_ =~ s/value=\'\'\>*\<\/textarea\>/value=\'\'\>$comupinfo\<\/textarea\>/;
            # 配列に格納
            $oneline[$cnt++] = $_;
        }elsif($fieldcnt == 2){
            # HTML 要素と改行付きコメントがあると想定しての処理
            $_ =~ s/value=\'\'\>.*/value=\'\'\>$comupinfo/;
            # 配列に格納
            $oneline[$cnt++] = $_;
            while(<YTF>){
                if($_ =~ /\<\/textarea\>/){
                    $_ =~ s/.*\<\/textarea\>/\<\/textarea\>/;
                    $oneline[$cnt++] = $_;
>>>>>>> b8103acd68cc7b4d7f09ad17c7d01afef190b31b
#	                print header();
#                    $_ =~ s/</＆ｌｔ;/g;
#                    $_ =~ s/>/＆ｇｔ;/g;
#	                print message("2:After Change FIlE(" . $_ . ")++++");
#	                print tailer();
                    last;
                }else{
<<<<<<< HEAD
                    $precoment = $precoment . $_;
=======
>>>>>>> b8103acd68cc7b4d7f09ad17c7d01afef190b31b
                    next;
                }
            }
        }else{
            # htagsで作成した形式と成り立たない
<<<<<<< HEAD
	        error_and_exit("HTML files format error. <a href='$basedir/mains.html'>Mains-list [return]</a>");
=======
	        error_and_exit("HTML files format error. <a href='../mains.html'>Mains-list [return]</a>");
>>>>>>> b8103acd68cc7b4d7f09ad17c7d01afef190b31b
        }
    }else{
        $oneline[$cnt++] = $_;
    }
<<<<<<< HEAD
=======
}
close(YTF);


open(WTF,">../$flnm")  or error_and_exit("Not Found temp.html");
print WTF @oneline;
close(WTF);

chdir($basedir);
if ($?) {
	error_and_exit("Change directory failed. <a href='../mains.html'>Mains-list [return]</a>");
>>>>>>> b8103acd68cc7b4d7f09ad17c7d01afef190b31b
}
close(YTF);
# 更新対象ファイルを読み込み処理終了


# 更新前にコメントがあればそれを表示し、すれ違いのない処理をする
#print header();
#print message("<pre>$precoment</pre>");
#print tailer();



# コメントアップ対象ファイルの上書き
open(WTF,">$basedir/S/$flnm")  or error_and_exit("Not Found $flnm");
print WTF @oneline;
close(WTF);


print header();
<<<<<<< HEAD
print message("<pre>$precoment</pre>");
print qq(<head><a href="$basedir/S/$flnm#$jmpoint" /></head>\n);;
#print qq(<head><meta http-equiv="Refresh" content="2; url=$basedir/S/$flnm#$jmpoint" /></head>\n);;
=======
print message("更新しました。確認ください。" . "<a href='$basedir/" . $flnm . "#" . $Lflnmid . "'>[確認]</a>");
#print @oneline;
>>>>>>> b8103acd68cc7b4d7f09ad17c7d01afef190b31b
print tailer();
#print @oneline;
exit 0;
